Bug 169299 - umount -l should work on hung NFS mounts with cached data
umount -l should work on hung NFS mounts with cached data
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: util-linux (Show other bugs)
4.0
All Linux
medium Severity medium
: ---
: ---
Assigned To: Amit Gud
Ben Levenson
: Reopened
Depends On:
Blocks: 176344 198694 235877
  Show dependency treegraph
 
Reported: 2005-09-26 14:27 EDT by Brad Hinson
Modified: 2007-11-30 17:07 EST (History)
4 users (show)

See Also:
Fixed In Version: RHSA-2007-0235
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-05-01 13:17:09 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
nfs-utils patch (15.46 KB, patch)
2006-07-25 15:33 EDT, Amit Gud
no flags Details | Diff
util-linux fix (489 bytes, patch)
2006-08-01 11:05 EDT, Amit Gud
no flags Details | Diff

  None (edit)
Description Brad Hinson 2005-09-26 14:27:26 EDT
Description of problem:
Currently, umount -l only works if there is no cached data waiting to be
read/written to the mount point.  This is a request to allow a way to forcefully
unmount, not caring about data loss.  For example, if the NFS server has gone
away never to return, a hung NFS mount with data waiting should be allowed to be
unmounted.  Requesting that this be considered for RHEL 


Version-Release number of selected component (if applicable):
util-linux-2.12a-16.EL4.6

How reproducible:
Initiate a write to the mountpoint, then take the NFS server down.  umount -l
will report that the device is busy.

Steps to Reproduce:
1. dd if=/dev/zero of=/mnt/point
2. take down NFS server
3. umount -l /mnt/point
  
Actual results:
umount: /mnt/point: device is busy

Expected results:
umount -l succeeds

Additional info:
Comment 11 Amit Gud 2006-07-25 15:33:11 EDT
Created attachment 133014 [details]
nfs-utils patch

I've incorporated the changes to my patch against latest nfs-utils, which can
be found at git://linux-nfs.org/nfs-utils
Comment 13 Amit Gud 2006-07-27 09:40:51 EDT
Created attachment 133149 [details]
lazy umount fix1

Patch in comment #6 is for util-linux. My patch in comment #11 is for nfs-utils
which is a complete patch that hasn't made it to the upstream + the changes
required for this bug fix. Alternatively you can use the attached patch which
is a fix for this bug on top of my patch for nfs-utils-1.0.9.
Comment 15 Amit Gud 2006-08-01 11:05:44 EDT
Created attachment 133403 [details]
util-linux fix

The bug needs fixing at two places in this case.

1. nfs-utils - if its is compiled with --enable-mount
2. util-linux - if nfs-utils is NOT compiled with --enable-mount

--enable-mount configure option in nfs-utils generates mount.nfs binary which
overrides all the NFS mount/umount operations which otherwise are performed by
util-linux. Latest patches to nfs-utils in rawhide add this option, which has
also been sent upstream.

Fix 1 (for nfs-utils) is in comment #13. Attached patch, which is actually a
port of patch in comment #6 to latest util-linux, is fix 2 (for util-linux).
Comment 16 Steve Dickson 2006-08-08 14:26:41 EDT
fixed in util-linux-2.12a-16.EL4.21
Comment 17 RHEL Product and Program Management 2006-08-18 13:19:00 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 21 Ben Levenson 2007-03-26 23:23:06 EDT
This fix is available in the latest RHEL-4.5 Beta.  If the customer is in
a position to test the beta, please ask for testing feedback. Thanks.
Comment 23 Red Hat Bugzilla 2007-05-01 13:17:09 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2007-0235.html

Note You need to log in before you can comment on or make changes to this bug.